#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 10 01:02:12 2021

@author: zhangwanwan
"""

import numpy as np
import pandas as pd
import plotly.offline as py
import plotly.graph_objs as go
#import matplotlib.pyplot as plt


df = pd.read_csv("datanew.csv")
df.columns = ['labels','date','p1','price']

prodata=pd.read_table(r'result8760.txt',       
          header=None,
         names=['id','prob'])

df['prob'] = 1-prodata['prob']
df['actualprofit1']= df['prob']*df['p1']*df['price']

timelength=6
#Function definition for maintenance profits 
def orignprofits1(x,PM,cost):
      if x < PM:
          return df.at[x, 'actualprofit1']
      elif x<PM+timelength:
          return cost
      else:
          return df.at[x, 'p1']*df.at[x, 'price']*df.at[x-PM-1, 'prob']


maintenancelist=[]#store maintenance timepoints
S=[]#Store all the maintenanceprofits
maxi= []#store maximum profits
t=0 #initial time point 
time=1447 #time period for loop
gap=710#Probability at 710h = 0.95
penalty=-1000
loopend=8660


#The first time period 
while t==0:
    lo=[]#collect sum maintenance profits at different PM
    for pm in range(t,t+time,1):#range from t to t+time-1
        df['profit1']= df[0:0+time]['labels'].apply(lambda x : orignprofits1(x, pm, -1000))
        v = df['profit1'].sum()
        lo.append(v)
    if max(lo[gap:])==penalty: # maintenance gap must be larger than 231h
        max_indx=time-1+t
    else:
        max_indx=np.argmax(lo[gap:])+gap+t
    index=max_indx-t #max_indx is real maintenance time, index is in lo
    j=lo[0:index+1]
    maintenancelist.append(max_indx)
    maxi.append(lo[index])
    S=S+j
    t=max_indx+timelength

def profits1(x,PM,cost):
      if x < PM:
          return df.at[x, 'p1']*df.at[x, 'price']*df.at[x-maintenancelist[-1]-1, 'prob']
    #x is between the last maintenance and the next maintenance
      elif x< PM+timelength:
          return cost
      else:
          return df.at[x, 'p1']*df.at[x, 'price']*df.at[x-PM-1, 'prob']
    #x is after the next maintenance 
    
#Begin the loop
while 0<t<loopend:
    lo=[]
    for pm in range(t,t+time,1):
        df['profit1']= df[t:t+time]['labels'].apply(lambda x : profits1(x, pm, -1000))
        v = df['profit1'].sum()
        lo.append(v)
    if max(lo[gap:])==penalty: # maintenance gap must be larger than 231h
        max_indx=time-1+t
    else:
        max_indx=np.argmax(lo[gap:])+t+gap
    index=max_indx-t #max_indx is real maintenance time, index is in lo
    j=lo[0:index+1]
    maintenancelist.append(max_indx)
    maxi.append(lo[index])
    S=S+j
    t=max_indx+1


#plot the result
print(len(S))
leng=len(S)
print(len(maintenancelist))





xs=np.arange(0,leng)
fig = go.Figure()
fig.add_trace(go.Scatter(x=xs,y=S[0:8761], mode='lines+markers', name = 'profit of PM'))
fig.add_trace(go.Scatter(x=maintenancelist,y=maxi,marker={'symbol':4,'size':10},
    mode = 'markers',
    name = 'maintenance dots'))
fig.layout.update(xaxis_title="<b>Time</b> (Hour)", yaxis_title="<b>Accumulated profit</b> (EUR)")
fig.show()
fig.layout.update(legend=dict(yanchor="top", y=0.99, xanchor="left", x=0.8))
py.plot(fig, filename='filename.html')

#save the result
dict1 = {'time':maintenancelist, 'value':maxi} 
dict2 = {'S':S} 
df1 = pd.DataFrame(dict1)
df2 = pd.DataFrame(dict2)
df1.to_csv('/Users/zhangwanwan/Desktop/Maintain.csv')
df2.to_csv('/Users/zhangwanwan/Desktop/S.csv')
df.to_csv('/Users/zhangwanwan/Desktop/New.csv')






